#include "operators.h"
#include <iostream>

double dot(const double a1[], const double a2[], std::size_t n) {
   double res(0);
   const double *it1 = a1, *it2 = a2;
   
   while(it1 < a1 + n) {
      res += *it1++ * *it2++;
   }
   return res;
}

void sum(double a1[], const double a2[], std::size_t n) {
   const double *it2 = a2;

   for(double *it1 = a1; it1 < a1 + n; ++it1, ++it2) 
      *it1 = *it1 + *it2;
} 

bool equal(const double a[], double test, std::size_t n) {
   for(std::size_t i = 0; i < n; ++i) {
      if(a[i] != test)
         return false;
   }
   return true;
}

bool testSumDot() {
   // test dot product
   const std::size_t n = 100;
   double a1[n]; 
   // initialize array with 1
   const double* a1End = a1 + n;
   double* it1 = a1;
   while(it1 < a1End)
      *it1++ = 1;

   if(n != dot(a1, a1, n)) {
      std::cerr << "dot test failed" << std::endl;
      return false;
   } else 
      std::cout << "dot test passed" << std::endl;

   // test sum
   sum(a1, a1, n);
   if(!equal(a1, 2, n)) {
      std::cerr << "sum test failed" << std::endl;
      return false;
   } else
      std::cout << "sum test passed" << std::endl; 

   return true;
}

